From cf67c1e5d9ccb40c71f7e91e68751b8b2aa6bab3 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Fri, 1 Dec 2023 16:50:30 +0100
Subject: [PATCH 32/54] feat!: cargo feature to enable libadwaita; disabled by
 default

---
 Makefile                                      |   3 +
 lact-gui/Cargo.toml                           |   5 +-
 lact-gui/src/app/dialogs.rs                   |  26 ++-
 lact-gui/src/app/headerbar.rs                 |  12 ++
 lact-gui/src/app/mod.rs                       | 165 ++++++++++++++--
 .../vulkan_info/feature_window/mod.rs         |  40 +++-
 .../root_stack/info_page/vulkan_info/mod.rs   |  64 ++++---
 lact-gui/src/app/root_stack/mod.rs            | 178 ++++++++++++++----
 .../app/root_stack/oc_page/clocks_frame.rs    |  75 ++++++--
 lact-gui/src/app/root_stack/oc_page/mod.rs    |  26 +--
 .../root_stack/oc_page/performance_frame.rs   | 127 ++++++++++---
 .../root_stack/oc_page/power_cap_section.rs   |  23 +++
 .../src/app/root_stack/thermals_page/mod.rs   |  23 ++-
 lact-gui/src/lib.rs                           |   6 +
 lact-gui/ui/oc_page/power_cap_section_gtk.blp |  36 ++++
 lact-gui/ui/vulkan_feature_row.blp            |  36 ++--
 lact-gui/ui/vulkan_features_window.blp        |  56 +++---
 lact-gui/ui/vulkan_features_window_gtk.blp    |  45 +++++
 18 files changed, 761 insertions(+), 185 deletions(-)
 create mode 100644 lact-gui/ui/oc_page/power_cap_section_gtk.blp
 create mode 100644 lact-gui/ui/vulkan_features_window_gtk.blp

diff --git a/Makefile b/Makefile
index 78c2549b..504e30e2 100644
--- a/Makefile
+++ b/Makefile
@@ -5,6 +5,9 @@ PREFIX ?= /usr/local
 build-release:
 	cargo build --release
 
+build-libadwaita-release:
+	cargo build --release --features libadwaita
+
 install:
 	install -Dm755 target/release/lact $(DESTDIR)$(PREFIX)/bin/lact
 	install -Dm644 res/lactd.service $(DESTDIR)$(PREFIX)/lib/systemd/system/lactd.service
diff --git a/lact-gui/Cargo.toml b/lact-gui/Cargo.toml
index 260a4268..efbeff5e 100644
--- a/lact-gui/Cargo.toml
+++ b/lact-gui/Cargo.toml
@@ -1,12 +1,13 @@
 [package]
 name = "lact-gui"
 version = "0.5.1"
-authors = ["Ilya Zlobintsev <ilya.zl@protonmail.com>"]
+authors = ["Ilya Zlobintsev <ilya.zl@protonmail.com>", "Gabriele Musco <gabmus@disroot.org>"]
 edition = "2021"
 
 [features]
 default = ["gtk-tests"]
 gtk-tests = []
+libadwaita = ["dep:libadwaita"]
 
 [dependencies]
 lact-client = { path = "../lact-client" }
@@ -15,7 +16,7 @@ gtk = { version = "0.7", package = "gtk4", features = ["v4_6", "blueprint"] }
 tracing = "0.1"
 tracing-subscriber = { version = "0.3", features = ["env-filter"] }
 anyhow = "1.0"
-libadwaita = { version = "0.5.3", features = ["v1_4"] }
+libadwaita = { version = "0.5.3", features = ["v1_4"], optional = true }
 
 [dev-dependencies]
 pretty_assertions = "1.4.0"
diff --git a/lact-gui/src/app/dialogs.rs b/lact-gui/src/app/dialogs.rs
index 2cad3e3d..af26c896 100644
--- a/lact-gui/src/app/dialogs.rs
+++ b/lact-gui/src/app/dialogs.rs
@@ -1,7 +1,10 @@
 use gtk::prelude::*;
-use libadwaita::prelude::MessageDialogExt;
 use tracing::warn;
 
+#[cfg(feature = "libadwaita")]
+use libadwaita::prelude::MessageDialogExt;
+
+#[cfg(feature = "libadwaita")]
 #[macro_export]
 macro_rules! info_dialog {
     ($parent:expr, $heading:expr, $body:expr, $response_id:expr, $response_txt:expr) => {{
@@ -20,6 +23,27 @@ macro_rules! info_dialog {
     }};
 }
 
+#[cfg(not(feature = "libadwaita"))]
+#[macro_export]
+macro_rules! info_dialog {
+    ($parent:expr, $heading:expr, $body:expr, $response_id:expr, $response_txt:expr) => {{
+        let diag = gtk::MessageDialog::builder()
+            .title($heading)
+            .text($body)
+            .modal(true)
+            .transient_for($parent)
+            .build();
+
+        diag.add_button($response_txt, gtk::ResponseType::Close);
+
+        diag.run_async(move |d, _| {
+            d.close();
+        });
+
+        diag
+    }};
+}
+
 pub fn show_error(parent: &impl IsA<gtk::Window>, err: anyhow::Error) {
     let text = format!("{err:?}");
     warn!("{}", text.trim());
diff --git a/lact-gui/src/app/headerbar.rs b/lact-gui/src/app/headerbar.rs
index f40bf774..de7cf279 100644
--- a/lact-gui/src/app/headerbar.rs
+++ b/lact-gui/src/app/headerbar.rs
@@ -2,14 +2,26 @@ use super::{apply_box::ApplyBox, gpu_selector::GpuSelector};
 
 #[derive(Debug, Clone)]
 pub struct Headerbar {
+    #[cfg(feature = "libadwaita")]
     pub container: libadwaita::HeaderBar,
+
+    #[cfg(not(feature = "libadwaita"))]
+    pub container: gtk::HeaderBar,
+
     pub gpu_selector: GpuSelector,
     pub apply_box: ApplyBox,
 }
 
 impl Headerbar {
     pub fn new() -> Self {
+        #[cfg(feature = "libadwaita")]
         let container = libadwaita::HeaderBar::builder().show_title(false).build();
+
+        #[cfg(not(feature = "libadwaita"))]
+        let container = gtk::HeaderBar::builder()
+            .title_widget(&gtk::Label::new(None))
+            .build();
+
         let gpu_selector = GpuSelector::new();
         let apply_box = ApplyBox::new();
 
diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index 5266982a..4fe4d84c 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -19,7 +19,6 @@ use lact_client::schema::request::{ConfirmCommand, SetClocksCommand};
 use lact_client::schema::DeviceStats;
 use lact_client::DaemonClient;
 use lact_daemon::MODULE_CONF_PATH;
-use libadwaita::prelude::{AdwApplicationWindowExt, MessageDialogExt};
 use root_stack::RootStack;
 use std::cell::RefCell;
 use std::rc::Rc;
@@ -27,13 +26,24 @@ use std::sync::atomic::AtomicBool;
 use std::time::Duration;
 use tracing::{debug, error, trace, warn};
 
+#[cfg(feature = "libadwaita")]
+use libadwaita::prelude::{AdwApplicationWindowExt, MessageDialogExt};
+
 // In ms
 const STATS_POLL_INTERVAL: u64 = 250;
 
 #[derive(Clone)]
 pub struct App {
+    #[cfg(feature = "libadwaita")]
     application: libadwaita::Application,
+    #[cfg(feature = "libadwaita")]
     pub window: libadwaita::ApplicationWindow,
+
+    #[cfg(not(feature = "libadwaita"))]
+    application: Application,
+    #[cfg(not(feature = "libadwaita"))]
+    pub window: ApplicationWindow,
+
     pub gpu_selector: GpuSelector,
     root_stack: RootStack,
     apply_box: ApplyBox,
@@ -42,8 +52,13 @@ pub struct App {
 
 impl App {
     pub fn new(daemon_client: DaemonClient) -> Self {
+        #[cfg(feature = "libadwaita")]
         let application = libadwaita::Application::new(Some(APP_ID), ApplicationFlags::default());
 
+        #[cfg(not(feature = "libadwaita"))]
+        let application = Application::new(Some(APP_ID), ApplicationFlags::default());
+
+        #[cfg(feature = "libadwaita")]
         let window = libadwaita::ApplicationWindow::builder()
             .title("LACT")
             .default_width(820)
@@ -53,6 +68,16 @@ impl App {
             .icon_name(APP_ID)
             .build();
 
+        #[cfg(not(feature = "libadwaita"))]
+        let window = ApplicationWindow::builder()
+            .title("LACT")
+            .default_width(820)
+            .default_height(750)
+            .width_request(420)
+            .height_request(200)
+            .icon_name(APP_ID)
+            .build();
+
         let system_info_buf = daemon_client
             .get_system_info()
             .expect("Could not fetch system info");
@@ -65,20 +90,38 @@ impl App {
 
         let root_stack = RootStack::new(&window, system_info, daemon_client.embedded);
 
-        let root_view = libadwaita::ToolbarView::new();
-
         let headerbar = Headerbar::new();
 
-        root_view.add_top_bar(&headerbar.container);
-        root_view.add_bottom_bar(
-            &libadwaita::ViewSwitcherBar::builder()
-                .reveal(true)
-                .stack(&root_stack.container)
-                .build(),
-        );
-        root_view.set_content(Some(&root_stack.container));
+        #[cfg(feature = "libadwaita")]
+        {
+            let root_view = libadwaita::ToolbarView::new();
+            root_view.add_top_bar(&headerbar.container);
+            root_view.add_bottom_bar(
+                &libadwaita::ViewSwitcherBar::builder()
+                    .reveal(true)
+                    .stack(&root_stack.container)
+                    .build(),
+            );
+            root_view.set_content(Some(&root_stack.container));
+            window.set_content(Some(&root_view));
+        }
 
-        window.set_content(Some(&root_view));
+        #[cfg(not(feature = "libadwaita"))]
+        {
+            let root_view = Box::builder().orientation(Orientation::Vertical).build();
+            root_view.append(&root_stack.container);
+            root_view.append(&Separator::new(Orientation::Horizontal));
+            root_view.append(
+                &StackSwitcher::builder()
+                    .stack(&root_stack.container)
+                    .halign(Align::Center)
+                    .vexpand(false)
+                    .hexpand(true)
+                    .build(),
+            );
+            window.set_titlebar(Some(&headerbar.container));
+            window.set_child(Some(&root_view));
+        }
 
         App {
             application,
@@ -201,7 +244,16 @@ impl App {
                             To enable the daemon, run the following command:"),
                         "close",
                         "_Close");
+
+                    #[cfg(feature = "libadwaita")]
                     diag.set_extra_child(Some(&hbox));
+
+                    #[cfg(not(feature = "libadwaita"))]
+                    {
+                        hbox.set_margin_start(12);
+                        hbox.set_margin_end(12);
+                        diag.first_child().unwrap().first_child().unwrap().downcast::<Box>().unwrap().append(&hbox);
+                    }
                 }
             }));
 
@@ -473,6 +525,7 @@ impl App {
         Ok(())
     }
 
+    #[cfg(feature = "libadwaita")]
     fn enable_overclocking(&self) {
         let text = format!("This will enable the overdrive feature of the amdgpu driver by creating a file at <b>{MODULE_CONF_PATH}</b>");
         let dialog = libadwaita::MessageDialog::builder()
@@ -517,6 +570,42 @@ impl App {
         dialog.present();
     }
 
+    #[cfg(not(feature = "libadwaita"))]
+    fn enable_overclocking(&self) {
+        let text = format!("This will enable the overdrive feature of the amdgpu driver by creating a file at <b>{MODULE_CONF_PATH}</b>. Are you sure you want to do this?");
+        let dialog = MessageDialog::builder()
+            .title("Enable Overclocking")
+            .use_markup(true)
+            .text(text)
+            .message_type(MessageType::Question)
+            .buttons(ButtonsType::OkCancel)
+            .transient_for(&self.window)
+            .build();
+
+        dialog.run_async(clone!(@strong self as app => move |diag, response| {
+            if response == ResponseType::Ok {
+                match app.daemon_client.enable_overdrive().and_then(|buffer| buffer.inner()) {
+                    Ok(_) => {
+                        let success_dialog = MessageDialog::builder()
+                            .title("Success")
+                            .text("Overclocking successfully enabled. A system reboot is required to apply the changes")
+                            .message_type(MessageType::Info)
+                            .buttons(ButtonsType::Ok)
+                            .build();
+                        success_dialog.run_async(move |diag, _| {
+                            diag.hide();
+                        });
+                    }
+                    Err(err) => {
+                        show_error(&app.window, err);
+                    }
+                }
+            }
+            diag.hide();
+        }));
+    }
+
+    #[cfg(feature = "libadwaita")]
     fn ask_confirmation(&self, gpu_id: String, mut delay: u64) {
         let text = confirmation_text(delay);
         let dialog = libadwaita::MessageDialog::builder()
@@ -578,6 +667,58 @@ impl App {
         );
         dialog.present();
     }
+
+    #[cfg(not(feature = "libadwaita"))]
+    fn ask_confirmation(&self, gpu_id: String, mut delay: u64) {
+        let text = confirmation_text(delay);
+        let dialog = MessageDialog::builder()
+            .title("Confirm settings")
+            .text(text)
+            .message_type(MessageType::Question)
+            .buttons(ButtonsType::YesNo)
+            .transient_for(&self.window)
+            .build();
+        let confirmed = Rc::new(AtomicBool::new(false));
+
+        glib::source::timeout_add_local(
+            Duration::from_secs(1),
+            clone!(@strong dialog, @strong self as app, @strong gpu_id, @strong confirmed => move || {
+                if confirmed.load(std::sync::atomic::Ordering::SeqCst) {
+                    return ControlFlow::Break;
+
+                }
+                delay -= 1;
+
+                let text = confirmation_text(delay);
+                dialog.set_text(Some(&text));
+
+                if delay == 0 {
+                    dialog.hide();
+                    app.set_initial(&gpu_id);
+
+                    ControlFlow::Break
+                }  else {
+                    ControlFlow::Continue
+                }
+            }),
+        );
+
+        dialog.run_async(clone!(@strong self as app => move |diag, response| {
+            confirmed.store(true, std::sync::atomic::Ordering::SeqCst);
+
+            let command = match response {
+                ResponseType::Yes => ConfirmCommand::Confirm,
+                _ => ConfirmCommand::Revert,
+            };
+
+            diag.hide();
+
+            if let Err(err) = app.daemon_client.confirm_pending_config(command) {
+                show_error(&app.window, err);
+            }
+            app.set_initial(&gpu_id);
+        }));
+    }
 }
 
 enum GuiUpdateMsg {
diff --git a/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/mod.rs b/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/mod.rs
index 349cf70a..4046dbde 100644
--- a/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/mod.rs
+++ b/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/mod.rs
@@ -4,12 +4,20 @@ mod row;
 use glib::Object;
 use gtk::{gio, glib};
 
+#[cfg(feature = "libadwaita")]
 glib::wrapper! {
     pub struct VulkanFeaturesWindow(ObjectSubclass<imp::VulkanFeaturesWindow>)
         @extends gtk::Box, gtk::Widget, gtk::Window, libadwaita::Window,
         @implements gtk::Orientable, gtk::Accessible, gtk::Buildable;
 }
 
+#[cfg(not(feature = "libadwaita"))]
+glib::wrapper! {
+    pub struct VulkanFeaturesWindow(ObjectSubclass<imp::VulkanFeaturesWindow>)
+        @extends gtk::Box, gtk::Widget, gtk::Window,
+        @implements gtk::Orientable, gtk::Accessible, gtk::Buildable;
+}
+
 impl VulkanFeaturesWindow {
     pub fn new(title: &str, model: gio::ListModel) -> Self {
         Object::builder()
@@ -33,9 +41,12 @@ mod imp {
         CompositeTemplate, Expression, FilterListModel, PropertyExpression, SearchEntry,
         SignalListItemFactory, StringFilter, TemplateChild,
     };
-    use libadwaita::subclass::window::AdwWindowImpl;
     use std::cell::RefCell;
 
+    #[cfg(feature = "libadwaita")]
+    use libadwaita::subclass::window::AdwWindowImpl;
+
+    #[cfg(feature = "libadwaita")]
     #[derive(CompositeTemplate, Properties, Default)]
     #[properties(wrapper_type = super::VulkanFeaturesWindow)]
     #[template(file = "ui/vulkan_features_window.blp")]
@@ -54,12 +65,36 @@ mod imp {
         search_entry: TemplateChild<SearchEntry>,
     }
 
+    #[cfg(not(feature = "libadwaita"))]
+    #[derive(CompositeTemplate, Properties, Default)]
+    #[properties(wrapper_type = super::VulkanFeaturesWindow)]
+    #[template(file = "ui/vulkan_features_window_gtk.blp")]
+    pub struct VulkanFeaturesWindow {
+        #[property(get, set)]
+        model: RefCell<Option<gio::ListModel>>,
+        #[template_child]
+        features_factory: TemplateChild<SignalListItemFactory>,
+
+        #[template_child]
+        filter_model: TemplateChild<FilterListModel>,
+
+        #[template_child]
+        search_filter: TemplateChild<StringFilter>,
+        #[template_child]
+        search_entry: TemplateChild<SearchEntry>,
+    }
+
     #[glib::object_subclass]
     impl ObjectSubclass for VulkanFeaturesWindow {
         const NAME: &'static str = "VulkanFeaturesWindow";
         type Type = super::VulkanFeaturesWindow;
+
+        #[cfg(feature = "libadwaita")]
         type ParentType = libadwaita::Window;
 
+        #[cfg(not(feature = "libadwaita"))]
+        type ParentType = gtk::Window;
+
         fn class_init(class: &mut Self::Class) {
             class.bind_template();
         }
@@ -117,6 +152,9 @@ mod imp {
 
     impl WidgetImpl for VulkanFeaturesWindow {}
     impl WindowImpl for VulkanFeaturesWindow {}
+
+    #[cfg(feature = "libadwaita")]
     impl AdwWindowImpl for VulkanFeaturesWindow {}
+
     impl ApplicationWindowImpl for VulkanFeaturesWindow {}
 }
diff --git a/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs b/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
index eb25bc6e..b4915c34 100644
--- a/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
+++ b/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
@@ -2,14 +2,16 @@ mod feature_window;
 
 use self::feature_window::VulkanFeaturesWindow;
 use crate::app::root_stack::info_page::vulkan_info::feature_window::feature::VulkanFeature;
-use crate::app::root_stack::LabelRow;
+use crate::app::root_stack::{action_row, LabelRow};
 use glib::clone;
 use gtk::prelude::*;
 use gtk::*;
 use lact_client::schema::VulkanInfo;
-use libadwaita::prelude::ActionRowExt;
 use tracing::trace;
 
+#[cfg(feature = "libadwaita")]
+use libadwaita::prelude::ActionRowExt;
+
 #[derive(Debug, Clone)]
 pub struct VulkanInfoFrame {
     pub container: ListBox,
@@ -41,25 +43,45 @@ impl VulkanInfoFrame {
         container.append(&driver_name_row.container);
         container.append(&driver_version_row.container);
 
-        let features_row = libadwaita::ActionRow::builder()
-            .activatable(true)
-            .title("Features")
-            .build();
-        features_row.add_suffix(&Image::from_icon_name("go-next-symbolic"));
-        features_row.connect_activated(clone!(@strong features_model => move |_| {
-            show_features_window("Vulkan features", features_model.clone());
-        }));
-        container.append(&features_row);
-
-        let extensions_row = libadwaita::ActionRow::builder()
-            .activatable(true)
-            .title("Extensions")
-            .build();
-        extensions_row.add_suffix(&Image::from_icon_name("go-next-symbolic"));
-        extensions_row.connect_activated(clone!(@strong extensions_model => move |_| {
-            show_features_window("Vulkan extensions", extensions_model.clone());
-        }));
-        container.append(&extensions_row);
+        #[cfg(feature = "libadwaita")]
+        {
+            let features_row = libadwaita::ActionRow::builder()
+                .activatable(true)
+                .title("Features")
+                .build();
+            features_row.add_suffix(&Image::from_icon_name("go-next-symbolic"));
+            features_row.connect_activated(clone!(@strong features_model => move |_| {
+                show_features_window("Vulkan features", features_model.clone());
+            }));
+            container.append(&features_row);
+
+            let extensions_row = libadwaita::ActionRow::builder()
+                .activatable(true)
+                .title("Extensions")
+                .build();
+            extensions_row.add_suffix(&Image::from_icon_name("go-next-symbolic"));
+            extensions_row.connect_activated(clone!(@strong extensions_model => move |_| {
+                show_features_window("Vulkan extensions", extensions_model.clone());
+            }));
+            container.append(&extensions_row);
+        }
+
+        #[cfg(not(feature = "libadwaita"))]
+        {
+            let features_btn = Button::builder().label("View").build();
+            features_btn.connect_clicked(clone!(@strong features_model => move |_| {
+                show_features_window("Vulkan features", features_model.clone());
+            }));
+            let features_row = action_row("Features", None, &[&features_btn], None);
+            container.append(&features_row);
+
+            let extensions_btn = Button::builder().label("View").build();
+            extensions_btn.connect_clicked(clone!(@strong extensions_model => move |_| {
+                show_features_window("Vulkan extensions", extensions_model.clone());
+            }));
+            let extensions_row = action_row("Extensions", None, &[&extensions_btn], None);
+            container.append(&extensions_row);
+        }
 
         Self {
             container,
diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index 68084723..54462e67 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -7,13 +7,21 @@ use self::software_page::software_page;
 use gtk::{prelude::IsA, *};
 use info_page::InformationPage;
 use lact_client::schema::SystemInfo;
-use libadwaita::prelude::ActionRowExt;
 use oc_page::OcPage;
 use thermals_page::ThermalsPage;
+use traits::BoxExt;
+use traits::WidgetExt;
+
+#[cfg(feature = "libadwaita")]
+use libadwaita::prelude::ActionRowExt;
 
 #[derive(Debug, Clone)]
 pub struct RootStack {
+    #[cfg(feature = "libadwaita")]
     pub container: libadwaita::ViewStack,
+    #[cfg(not(feature = "libadwaita"))]
+    pub container: Stack,
+
     pub info_page: InformationPage,
     pub thermals_page: ThermalsPage,
     pub oc_page: OcPage,
@@ -25,45 +33,54 @@ impl RootStack {
         system_info: SystemInfo,
         embedded_daemon: bool,
     ) -> Self {
+        #[cfg(feature = "libadwaita")]
         let container = libadwaita::ViewStack::builder()
             .vexpand(true)
             .hexpand(true)
             .build();
+        #[cfg(not(feature = "libadwaita"))]
+        let container = Stack::builder().vexpand(true).hexpand(true).build();
 
         let info_page = InformationPage::new();
-
-        container.add_titled_with_icon(
-            &info_page.container,
-            Some("info_page"),
-            "Information",
-            "info-symbolic",
-        );
-
         let oc_page = OcPage::new(&system_info);
-
-        container.add_titled_with_icon(
-            &oc_page.container,
-            Some("oc_page"),
-            "Overclock",
-            "power-profile-performance-symbolic",
-        );
-
         let thermals_page = ThermalsPage::new(root_win);
+        let software_page = software_page(system_info, embedded_daemon);
 
-        container.add_titled_with_icon(
-            &thermals_page.container,
-            Some("thermals_page"),
-            "Thermals",
-            "temperature-symbolic",
-        );
+        #[cfg(feature = "libadwaita")]
+        {
+            container.add_titled_with_icon(
+                &info_page.container,
+                Some("info_page"),
+                "Information",
+                "info-symbolic",
+            );
+            container.add_titled_with_icon(
+                &oc_page.container,
+                Some("oc_page"),
+                "Overclock",
+                "power-profile-performance-symbolic",
+            );
+            container.add_titled_with_icon(
+                &thermals_page.container,
+                Some("thermals_page"),
+                "Thermals",
+                "temperature-symbolic",
+            );
+            container.add_titled_with_icon(
+                &software_page,
+                Some("software_page"),
+                "Software",
+                "preferences-other-symbolic",
+            );
+        }
 
-        let software_page = software_page(system_info, embedded_daemon);
-        container.add_titled_with_icon(
-            &software_page,
-            Some("software_page"),
-            "Software",
-            "preferences-other-symbolic",
-        );
+        #[cfg(not(feature = "libadwaita"))]
+        {
+            container.add_titled(&info_page.container, Some("info_page"), "Information");
+            container.add_titled(&oc_page.container, Some("oc_page"), "Overclock");
+            container.add_titled(&thermals_page.container, Some("thermals_page"), "Thermals");
+            container.add_titled(&software_page, Some("software_page"), "Software");
+        }
 
         Self {
             container,
@@ -76,13 +93,17 @@ impl RootStack {
 
 #[derive(Debug, Clone)]
 pub struct LabelRow {
+    #[cfg(feature = "libadwaita")]
     pub container: libadwaita::ActionRow,
+
+    #[cfg(not(feature = "libadwaita"))]
+    pub container: ListBoxRow,
+
     content_label: Label,
 }
 
 impl LabelRow {
     pub fn new(title: &str) -> Self {
-        let container = libadwaita::ActionRow::builder().title(title).build();
         let label = Label::builder()
             .css_classes(["dim-label"])
             .ellipsize(pango::EllipsizeMode::End)
@@ -90,7 +111,8 @@ impl LabelRow {
             .justify(Justification::Right)
             .selectable(true)
             .build();
-        container.add_suffix(&label);
+
+        let container = action_row(title, None, &[&label], None);
 
         Self {
             container,
@@ -109,6 +131,7 @@ impl LabelRow {
     }
 }
 
+#[cfg(feature = "libadwaita")]
 pub fn list_clamp(child: &impl IsA<Widget>) -> libadwaita::Clamp {
     libadwaita::Clamp::builder()
         .maximum_size(600)
@@ -120,3 +143,94 @@ pub fn list_clamp(child: &impl IsA<Widget>) -> libadwaita::Clamp {
         .valign(Align::Start)
         .build()
 }
+
+#[cfg(not(feature = "libadwaita"))]
+pub fn list_clamp(child: &impl IsA<Widget>) -> Box {
+    let container = Box::builder()
+        .margin_top(24)
+        .margin_bottom(24)
+        .margin_start(6)
+        .margin_end(6)
+        .orientation(Orientation::Vertical)
+        .valign(Align::Start)
+        .build();
+    container.append(child);
+
+    container
+}
+
+#[cfg(feature = "libadwaita")]
+pub fn action_row(
+    title: &str,
+    subtitle: Option<&str>,
+    suffixes: &[&impl IsA<Widget>],
+    css_classes: Option<&[&str]>,
+) -> libadwaita::ActionRow {
+    let ar = libadwaita::ActionRow::builder()
+        .subtitle_lines(0)
+        .title(title)
+        .build();
+
+    if let Some(css) = css_classes {
+        css.iter().for_each(|cls| ar.add_css_class(cls));
+    }
+
+    if let Some(sub) = subtitle {
+        ar.set_subtitle(sub);
+    }
+    suffixes.iter().for_each(|suf| {
+        ar.add_suffix(*suf);
+    });
+    ar
+}
+
+#[cfg(not(feature = "libadwaita"))]
+pub fn action_row(
+    title: &str,
+    subtitle: Option<&str>,
+    suffixes: &[&impl IsA<Widget>],
+    css_classes: Option<&[&str]>,
+) -> ListBoxRow {
+    let inner = Box::builder()
+        .orientation(Orientation::Horizontal)
+        .margin_top(12)
+        .margin_bottom(12)
+        .margin_start(12)
+        .margin_end(12)
+        .build();
+
+    if let Some(css) = css_classes {
+        css.iter().for_each(|cls| inner.add_css_class(cls));
+    }
+
+    let title_label = Label::builder()
+        .label(title)
+        .css_classes(["heading"])
+        .hexpand(true)
+        .xalign(0.0)
+        .wrap(true)
+        .wrap_mode(pango::WrapMode::Word)
+        .build();
+    if let Some(sub) = subtitle {
+        let vert = Box::new(Orientation::Vertical, 6);
+        vert.append(&title_label);
+        vert.append(
+            &Label::builder()
+                .label(sub)
+                .hexpand(true)
+                .xalign(0.0)
+                .wrap(true)
+                .wrap_mode(pango::WrapMode::Word)
+                .build(),
+        );
+        inner.append(&vert);
+    } else {
+        inner.append(&title_label);
+    }
+
+    suffixes.iter().for_each(|suf| {
+        inner.append(*suf);
+    });
+
+    ListBoxRow::builder().child(&inner).build()
+}
